/* main.c */

#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include <unistd.h>
#include "globals.h"

#define HEAD_START 10000    /* microseconds */

extern void read_inputs (Input **);
extern void put_subtitle (int, int, Image *);
extern void init (int, char **);
extern void handle_events (void);

int main (int argc, char **argv) {
    Input *list;
    struct timeval origin_tv, now_tv, temp_tv;
    long origin, now, target, temp;

    radius = 2;    /* global */

    /* pre-parse input */
    init (argc, argv);
    read_inputs (&list);
    gettimeofday (&origin_tv, NULL);
    origin = TIMEVAL_IN_USEC (origin_tv);

    while (list != NULL) {
	gettimeofday (&now_tv, NULL);
	now = TIMEVAL_IN_USEC (now_tv);
	target = list->time;
	if (origin+target < now + HEAD_START) {
	    put_subtitle (list->x, list->y, list->image);
	    gettimeofday (&temp_tv, NULL);
	    temp = TIMEVAL_IN_USEC (temp_tv);
	    printf ("%+f\n", (temp-(origin+target))/1000000.0);
	    list = list->next;
	}
	else
	    usleep (10000);
	handle_events ();
    }

    while (1) {
	handle_events ();
	usleep (30000);
    }
}
